Numerous fixes, enhancements and updation to TODO list in bldpkg

This commit is contained in:
PktSurf 2022-09-08 11:04:25 +05:30
parent 549283c0b8
commit 4a48417c00
2 changed files with 55 additions and 41 deletions

View file

@ -37,4 +37,4 @@ build() {
sha512sums="
4c195f96d5c1d0dbd3c2c4c46dda2a4675c65e2cffa6b0ce7ee71d656a32dc75a6bb4d2b111395a1c01dfa7f1a0ccf579221fb63da72af7e4b9ac4b966debc29 libical-3.0.8.tar.lz
98b0b685676e7aa54e49050ec8adab4bb6cd3827fcd3977c156d841a527268cb47b3227852036f4bb195931ae8295fa6761bc96f4d4042f059193ab6f75aa27a icu-68.patch
"
"

94
bldpkg
View file

@ -22,12 +22,11 @@
# TODO
# -> Uncomment entirety of the code where compilers are to be hard-validated and improve C code
# in the test files and also add suitable bldpkg.conf switches for it
# -> Give a warning when more than two directories, a source and a staging directory
# not belonging to the current build are present inside tmpfs
# -> Write code to log build output to a log file inside a particular directory
# -> Add code to show extended help?
# -> Email the user about the outcome of the build?
# -> Use 'cat' instead of 'echo' for generating summary
# -> Use 'select' bash builtin instead of while true/case/esac
# -> Remove static libraries by default unless preservestaticlibs is set to 1?
# Determine whether we are using bash version 4 and later. If not, exit.
if ((BASH_VERSINFO[0] < 4)) ; then
@ -214,8 +213,7 @@ if [[ $OPTIND = 1 ]] ; then
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
else
validatebldfile $buildfile
if [[ $? != 0 ]] ; then
if ! validatebldfile $buildfile ; then
echo "[ERROR] Build file validation failed!"
exit 1
else
@ -253,8 +251,7 @@ elif [[ $OPTIND -gt 1 ]] ; then
fi
fi
validatebldfile "$origbuildfile"
if [[ $? != 0 ]] ; then
if ! validatebldfile "$origbuildfile" ; then
echo "[ERROR] Alternative build file validation failed!"
exit 1
fi
@ -264,8 +261,12 @@ elif [[ $OPTIND -gt 1 ]] ; then
# If $setbuildfile is set and is a file, set buildfile to its value, source it and initialise the build
if [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
buildfile="$setbuildfile"
validatebldfile $buildfile
source "$buildfile"
if ! validatebldfile $buildfile ; then
echo "[ERROR] $buildfile validation failed!"
exit 1
else
source "$buildfile"
fi
# If $setbuildfile is set but a file passed as an argument is not found, give an error
elif [[ -n $setbuildfile ]] && [[ ! -f $setbuildfile ]] ; then
@ -274,8 +275,12 @@ elif [[ $OPTIND -gt 1 ]] ; then
# If the above two conditions don't meet, get the presumed $buildfile value as a file and source it
elif [[ -f "$buildfile" ]] ; then
validatebldfile $buildfile
source "$buildfile"
if ! validatebldfile $buildfile ; then
echo "[ERROR] $buildfile validation failed!"
exit 1
else
source "$buildfile"
fi
# If even that file is not found, throw an error and exit
else
@ -314,6 +319,11 @@ if [[ $genchecksum = 1 ]] ; then
done
printf '"' >> "$buildfile"
if [[ "$(find . -type d -maxdepth 1 -print0 | wc -l)" -ge 1 ]]; then
echo "[WARNING] SHA512 checksums not generated for files inside directories!"
fi
echo "[INFO] You may now run bldpkg again"
exit 0
fi
@ -348,8 +358,8 @@ fi
terminateauditd() {
if [[ $useauditd = 1 ]] ; then
# Terminate auditd, log number of lines inside a variable
/bin/kill -15 "$auditpid"
echo "[INFO] Auditd terminated."
/bin/kill "$auditpid"
echo "[INFO] Auditd stopped."
auditlogtermsize="$(wc -l < $auditlogfile)"
@ -361,31 +371,27 @@ terminateauditd() {
fi
}
# Only verify source checksums if skipchecksum is not set in the build file
if [[ -z $skipchecksum ]] ; then
if [[ -z $sha512sums ]] ; then
echo "[ERROR] SHA512 checksums don't exist in $buildfile !"
echo "[ERROR] Please run 'bldpkg -g' to add them"
# sha512sums variable is expected in every single package build file
if [[ -z $sha512sums ]] ; then
echo "[ERROR] SHA512 checksums don't exist in $buildfile !"
echo "[ERROR] Please run 'bldpkg -g' to add them"
exit 1
fi
eval sums=\"\$sha512sums\"
echo "[INFO] Verifying SHA512 checksums against source files..."
IFS=$'\n'
for src in $sums; do
if ! echo $src | sha512sum -c ; then
echo "[ERROR] Checksums failed to match!"
exit 1
fi
eval sums=\"\$sha512sums\"
done
echo "[INFO] Verifying SHA512 checksums against source files..."
IFS=$'\n'
for src in $sums; do
echo $src | sha512sum -c
checksumresult=$?
if [[ $checksumresult != 0 ]] ; then
echo "[ERROR] Checksums failed to match!"
exit 1
fi
done
unset IFS
fi
unset IFS
# Function to output to the user which patch is about to be applied. Useful when there are many
# patches and you want to determine which patch failed.
@ -535,6 +541,14 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]]; then
fi
# Discard the file used to test the tmp directory
[[ -e "$tmpfsdir/.smlinuxtmpwritetest" ]] && rm -f "$tmpfsdir/.smlinuxtmpwritetest"
# Check the tmpfsdir for stale directories other than the current package about to be built. If found, issue a warning.
if [[ "$(find $tmpfsdir -type d -maxdepth 1 -print0 | wc -l)" -gt 1 ]]; then
if [[ ! -d $app.src ]] || [[ ! -d package-$app ]] ; then
echo "[WARNING] TMPFS directory has stale directories from previous builds!"
sleep 5
fi
fi
fi
# Validate system swap if swapcheck is defined and set to 1
@ -954,13 +968,13 @@ fixbuilddirpermissions() {
echo " done."
}
#https://gist.github.com/ruario/9672717
# https://gist.github.com/ruario/9672717
# Custom function from the above author for creating a slackware package. Entirely removes the need to use slackware's makepkg.
makepkg() {
echo "[INFO] Generating SMLinux package..."
# If $disablepkgsymlinks is not set in the package build file, change any symlinks
#into shell script code
# If $disablepkgsymlinks is not set in the package build file, change any symlinks into shell script code
if [[ -z $disablepkgsymlinks ]] ; then
if find * -type l | grep -qm1 .; then
echo "[INFO] Found symlinks, preparing install/doinst.sh..."
@ -976,7 +990,7 @@ makepkg() {
--xform 'sx^\./\(.\)x\1x' \
--show-stored-names | $compressor $compressoropts > "$newpkglocation"
echo ""
echo "[INFO] SMLinux package $newpkglocation created."
echo "[INFO] SMLinux package '"$app-$version-$arch-$build.$pkgext"' successfully generated in $pkgdest."
}
@ -1552,7 +1566,7 @@ interruptoutput() {
# https://stackoverflow.com/questions/9256644/identifying-received-signal-name-in-bash/9256709
# We use two traps to identify the signals, EXIT and INT. EXIT will invoke 'prepbuildoutput' function on any exit
# status >= 0. The script fail status is determined by the above pkgstatus or any premature compile failure.
# The 'interrruptsummary' function is invoked when the user sends CTRL-C aka SIGINT. The SIGINT trap does not work
# The 'interruptoutput' function is invoked when the user sends CTRL-C aka SIGINT. The SIGINT trap does not work
# for auto builds, it has been added in the section build file too.
trap "prepbuildoutput" EXIT